// ------------------------------
// Filename      : landscape.h
// Author        : Sven Maerivoet
// Last modified : 11/04/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifndef SM_LANDSCAPE_H // include-guard
#define SM_LANDSCAPE_H

#include "opengl/opengl.h"
#include "opengl/primitives.h"
#include "opengl/rgbapixmap.h"
#include "opengl/terrainmap.h"

using namespace std;

class LandscapeGLApp : public TOpenGLApp {
  public:
    // constructor
    LandscapeGLApp(void);

    // destructor
    ~LandscapeGLApp(void);

    // explicit initialization
    void explicitInitialize(void);

    // callback-functions
    void displayFunc(void);
    void myDisplayFunc(void);
    void keyboardFunc(unsigned char key, int x, int y);
    void idleFunc(void);

  private:
    // data-members
    bool        fAntiAlias;
    bool        fFogEnabled;
    bool        fUseLandscapeMaterials;
    bool        fUseTextureMaps;
    bool        fSmoothenVertexNormals;
    Rectangle2D fBounds;
    RGBApixmap* fSeaTexture;
    RGBApixmap* fMountainTexture;
    RGBApixmap* fSnowTexture;
    int         fTimePeriod;
    int         fCurrentTime;
    TerrainMap  fTerrainMap;
};

#endif
