// ------------------------------
// Filename      : chrono.h
// Author        : Sven Maerivoet
// Last modified : 20/04/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifdef _WIN32
  #include <windows.h>
#endif

#include <string>
#include <time.h>

// string-streams are not always compatible
// => Microsoft Visual C++ 6.0 and UNIX/Linux are treated separately
#ifdef _WIN32
  #include <sstream>
#else
  #include <strstream>
  #define  ostringstream ostrstream
#endif

using namespace std;

class Chrono {
  public:
    // constructor
    Chrono(void);

    // destructor
    ~Chrono(void);

    // methods
    void start(void);
    void stop(void);
    long getElapsedTime(void);
    static string convertToHMS(long elapsedTime);

  private:
    // utility methods
    static string convertIntToString(int x);

    // data-members
    bool fRunning;
    long fElapsedTime;
    long fStartTime;
};
