// --------------------------------------
// Filename      : proceduraltexturer.cpp
// Author        : Sven Maerivoet
// Last modified : 20/04/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// --------------------------------------

#ifdef _WIN32
  #include <windows.h>
#endif

#include "math.h"
#include "proceduraltexturer.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

// ------------------------
// class ProceduralTexturer
// ------------------------

// -----------
// constructor
// -----------
ProceduralTexturer::ProceduralTexturer(void)
{
}

// ----------
// destructor
// ----------
ProceduralTexturer::~ProceduralTexturer(void)
{
}

// -------
// methods
// -------
void ProceduralTexturer::initialize(void)
{
}

Color ProceduralTexturer::sampleCheckerboard(double s, double t,
                                             int tileS, int tileT) const
{
  int sPrime = (int) floor(s * tileS);
  int tPrime = (int) floor(t * tileT);

  if (((sPrime + tPrime) % 2) == 0) {
    return Color(0.0,0.0,0.0f);    
  }
  else {
    return Color(1.0,1.0,1.0f);    
  }
}

Color ProceduralTexturer::sampleRadialColors(double s, double t,
                                             const Color& insideColor,
                                             const Color& outsideColor) const
{
  double distance = sqrt(Math::sqr(s - 0.5) + Math::sqr(t - 0.5));
  double maxDistance = sqrt(2.0);

  return (insideColor + ((outsideColor - insideColor) * (distance / maxDistance)));
}
