// ------------------------------------
// Filename      : proceduraltexturer.h
// Author        : Sven Maerivoet
// Last modified : 13/03/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------------

#ifndef SM_PROCEDURALTEXTURER_H // include-guard
#define SM_PROCEDURALTEXTURER_H

#include "primitives.h"

using namespace std;

class ProceduralTexturer {
  public:
    // some useful constants
    enum EProceduralTextureType {kNone,
                                 kCheckerboard,
                                 kRadialColors};

    // constructor
    ProceduralTexturer(void);

    // destructor
    ~ProceduralTexturer(void);

    // methods
    void initialize(void);
    Color sampleCheckerboard(double s, double t,
                             int tileS, int tileT) const;
    Color sampleRadialColors(double s, double t,
                             const Color& insideColor,
                             const Color& outsideColor) const;
};

#endif
